<?php

function prosepoint_config_channels() {
  global $channels_table;
  
  module_load_include('inc', 'taxonomy', 'taxonomy.admin'); 
  $channels = array(
    'name' => 'Channel',
    'description' => '',
    'help' => 'Please select which channel this node belongs to. Hold down CTRL and click to select more than one',
    'nodes' => array('story' => TRUE),
    'tags' => 0,
    'multiple' => TRUE,
    'required' => 0,
    'weight' => 0,
  );
  $data = array('values' => $channels);
  drupal_execute('taxonomy_form_vocabulary', $data);
  $vid = $data['vid'];

  // Poke in 'module'
  db_query("UPDATE {vocabulary} SET module = '%s' WHERE vid = %d", 'pp_ch', $vid);

  variable_set('pp_ch_channel_vocabulary', $vid);
  
  $vocabs = taxonomy_get_vocabularies();
  $vocab = $vocabs[$vid];

  prosepoint_config_channels_data_init();
  foreach ($channels_table as $k => $term) {
    $channels_table[$k] = prosepoint_config_insert_channel_term($term, $vocab, 0);
  }
  
  return;      
}

function prosepoint_config_insert_channel_term($term, $vocab, $parent) {
  $data = array('values' =>
    array(
      'name' => $term['#name'],
      'description' => $term['#description'],
      'weight' => $term['#weight'],
    )
  );
  drupal_execute('taxonomy_form_term', $data, $vocab);
  $tid = $data['tid'];
  $block_display = $term['#editions_enable'] ? serialize(array('mode' => 'schedule', 'view' => 'teaser', 'count' => 5)) : serialize(array('mode' => 'list', 'view' => 'title', 'count' => 5));
  db_query("INSERT INTO {term_channels} (tid, vid, editions_enable, current_edition_nid, next_edition_nid, block_display, data) VALUES (%d, %d, %d, %d, %d, '%s', '%s')", $tid, $vocab->vid, $term['#editions_enable'] ? 1 : 0, 0, 0, $block_display, serialize(array('title_on_channel_page' => 1, 'title_on_listing_page' => 1)));

  if ($parent) {
    db_query("UPDATE {term_hierarchy} SET parent = %d WHERE tid = %d", $parent, $tid);
  }

  // Now recursively do the children (if any)
  foreach (element_children($term) as $k) {
    $child_term = $term[$k];
    if (is_array($child_term) && $child_term['#name']) {
      $term[$k] = prosepoint_config_insert_channel_term($child_term, $vocab, $tid);
    }
  }
  $term['tid'] = $tid;
  return $term;
}

function prosepoint_config_taxonomy() {
  global $node_table;
  if (empty($node_table))
    return;

  foreach ($node_table as $k => $v) {
    if (!empty($v['values']['terms'])) {
      $nid = $v['nid'];
      foreach ($v['values']['terms'] as $name) {
        $term = db_fetch_object(db_query("SELECT tid, vid FROM {term_data} WHERE name = '%s'", $name));
        if ($term) {
          db_query("INSERT INTO {term_node} (nid, vid, tid) VALUES (%d, %d, %d)", $nid, $nid, $term->tid);
        }
      }
    }
  }
}

